; 2008-2009, Vilga Savelieva, Saint Petersburg, Russia (with the assistance of N.Poleshchuk)
; Creating a desk organizer. Illustration to to chapter 10 of D.Abbott's book
; "AutoCAD: Secrets Every user Should Know"
; (American edition: 2007, Wiley Publishing, USA;
; translation into Russian: 2008, BHV-Petersburg, Russian Federation)
;=======================================================================
; For AutoCAD 2007-2009. EXTRUDE command in AutoCAD 2002-2006 uses one more question.
; Usage: 1. Create a new drawing with acadiso.dwt template;
; 2. Load this file; 3. Enter in command line (deskorganizer)
; Note. Express Tools are used.
;
(defun deskorganizer ( / oldecho pt1 pt2 pt3 pt4 olddpl oldosm dl zn6 zn92 zn50 xc 
	r pe1 pe2 pe3 pe4 k rr te ob eelast gla pletters rletters)
(setq oldecho (getvar "CMDECHO"))
(setvar "CMDECHO" 0)
(command "_.VPOINT" (list 1 -1 1))
(command "_.UCS" "_N" "3" '(0 0 0) '(0 1 0) '(0 0 1))
  ; Saving variables
  (setq olddpl (getvar "DISPSILH")
        oldosm (getvar "OSMODE")
  );setq
  ; Setting system variables 
  (setvar "DISPSILH" 1)
  (setvar "OSMODE" 0)
  (setvar "ISOLINES" 0)
  ; Side
  (setq pt1 (list 0 0 0)
	pt2 (list 100 0 0)
	pt3 (list 100 76 0)
	pt4 (list 0 26 0)
  );setq
  (command "_.PLINE" pt1 pt2 pt3 pt4 "_C")
  (command "_.EXTRUDE" (entlast) "" (setq dl 300))
  (setq gla (entlast))
  (command "_.UCS" 3 pt4 (list 0 (nth 1 pt4) dl) pt3)
  (command "_.UCS" "_S" "Slope"); UCS name
  (command "_.UCS" ""); world
  (command "_.-VPORTS" "4"); Creating 4 viewports
;;; 4 viewports
  ;------------------ 
  ;   4    |    3   |
  ;-------------------
  ;   5    |    2   |
  ;-------------------
  ; Viewports are activated with CVPORT
  (setvar "CVPORT" 4);LEFT upper
  (command "_.VPOINT" (list 0 0 1));
  (command "_.ZOOM" "_E")
  
  (setvar "CVPORT" 3);RIGHT upper (isometry)
  (command "_.ZOOM" "_E")
 
  (setvar "CVPORT" 5);LEFT lower
  (command "_.VPOINT" (list 0 1 0));
  (command "_.ZOOM" "_E")

  (setvar "CVPORT" 2);RIGHT lower
  (command "_.VPOINT" (list 1 0 0));
  (command "_.ZOOM" "_E")

  (setvar "CVPORT" 4); 
  (setq zn6 6 zn92 92 zn50 50)
  ; Building 3 pockets with fillet
  (setq k 0)
  (repeat 3
    (command "_.RECTANG" "_F" zn6  (setq ob (list (+ (* zn6 (1+ k)) (* zn92 k)) zn6 zn6))
                                  (list (+ (* zn6 (1+ k)) (* zn92 (1+ k))) zn50 zn6))
    (command "_.EXTRUDE" (entlast) "" 80)
    (command "_.SUBTRACT" gla "" ob "")
    (setq k (1+ k))
  );repeat
  (command "_.RECTANG" "_F" zn6 (list 98 64 6) (list 294 94 6))
  (command "_.EXTRUDE" (entlast) "" 80)
  (setq rr (entlast))
  (command "_.SUBTRACT" gla "" rr "")
  (command "_.ZOOM" "_E")
  (setq r 18 ; radius
  );setq
  (setq pe1 (list 24.0 93.0 6.0)
	pe2 (list 74.0 93.0 6.0)
	pe3 (list 24.0 57. 6.0)
	pe4 (list 74.0 57.0 6.0)
  );
  ; Creating oval
  (command "_.PLINE" pe2 pe1 "_A" "_R" r pe3 "_L" pe4  "_A" "_R" r pe2 "")
  (command "_.EXTRUDE" (entlast) "" 80)
  (setq eelast (entlast))
  (command "_.SUBTRACT" gla "" eelast "")
  (setvar "CVPORT" 3);LEFT upper, isometry
  (command "_.-VPORTS" "_SI")
  (command "_.ZOOM" "_E")
  (command "_.FILLET" (list 0.0 0.0 10.0) zn6
                     (list 0.0 100.0 50.0) (list 300.0 100.0 50.0) (list 300.0 0.0 5.0) "")
  (command "_.UCS" "_R" "Slope")
  (command "_.PLAN" "")
  (command "_.HIDE" "")
  (command "_.STYLE" "style-for-penal" "Arial.ttf" "" "" "" "" "")
  ; Remember the last entity for building solids in the form of text
  (setq eelast (entlast))
  (command "_.TEXT" "_J" "_F"  (list 98 60) (list 294 60) 7
	   "AutoCAD: Secrets Every User Should Know")
  (setq te (entlast))
  (command "_.PLAN" "_U" "Slope"); for TXTEXP
;;;  (command "TXTEXP" te); does not work
  (sssetfirst nil (ssget "_L")); select object (to be used by TXTEXP command)
  (c:txtexp); we get hevyweight polylines
  (setq pletters nil)
  ; Adding POLYLINEs only
  (while (setq eelast (entnext eelast))
    (if (= (cdr (assoc 0 (entget eelast))) "POLYLINE")
      (setq pletters (append pletters (list eelast)))
    );if
  );while
  (setq rletters nil)
  (while pletters
    (command "_.REGION" (car pletters) "")
    (setq rletters (append rletters (list (entlast))))
    (setq pletters (cdr pletters))
  );while
; Subtraction. gla retains old address
  (while rletters
    (command "_.EXTRUDE" (car rletters) "" -4.0)
    (command "_.SUBTRACT" gla "" (entlast) "")
    (setq rletters (cdr rletters))
  );while

  ; Restoring 
  (command "_.UCS" "")
  (setvar "DISPSILH" olddpl)
  (setvar "OSMODE" oldosm)
  (setvar "CMDECHO" oldecho)

  (princ)
  
);defun deskorganizer


